#MOJO_IMAGE_FILTERING_ENABLED="false"

Import mojo
#If TARGET="ios"
Import brl.gamecenter
#End

Import JMTrackr
Public Global HasMusic=1

Public Global jscrw:Float=640
Public Global jscrh:Float=480

Public Global rawscrw:Float=640
Public Global rawscrh:Float=480

Public Global DebugMode=0
Public Global OnScreenControls=0
Public Global AccelerometerControls=0

Const HasWordList=1	' Don't forget to remove the wordlist.png image if your game doesn't use the wordlist
					' otherwise you've an extra 800Kb crammed on your game for no reason.

Const MaxGames=3	' Number of Games / Difficulties / whatever
Const MaxHigh=10	' Number of Highscores per Game
Const MaxBadges=0	' Number of Achievable Badges

Const LeaderBoard_ID$="com.agameaweek.AGAW_GameName_Score_"
Const Badge_ID$="com.agameaweek.AGAW_GameName_Badge_"

#If TARGET="ios"
	Const MaxSprites=500
	Const MaxChannels=32
	
#Elseif TARGET="html5"
	Const MaxSprites=2500
	Const MaxChannels=8
	
#Else
	Const MaxSprites=2500
	Const MaxChannels=32
#End


Public Global iCadeControls=0

Class MyApp Extends App

	Field MusicPlayer:JMPlayer=New JMPlayer

	Field Score,ShowScore:Int
	Field EndofGame,Ending:Int	

	Field wr=0
	Field GameMode,GameType:Int
	Field MenuIn,BarWide:Float
	Field RandomSeed:Int
	Field CreditsOn=0
	Field BadgesOn=0
	Field BadgesScr#,BadgesAimScr#
	
	Field ToSprites:Int
	Field Orientation:Int

	Field lmsr,lmsu,fpsr,fpsu,fpsra,fpsua:Int

	Field sfx:Sound[100]
	Field chan:Int[MaxChannels+1]
	Field LChan:Int

	Field Set:Int[25]
	Field High:Int[MaxGames*MaxHigh*5]
	Field Badge:Bool[256]
	Field BadgeSent:Bool[256]
	
	Field img:Image[100]
	Field imgd:Int[300]
	Field sprt:Float[(MaxSprites)*15]
	Field sprtup:Int

	Field Paused,PausedIn,PausedMove,PausedMenu:Int

	Field a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z:Int
	Field mx,my,mwx,mwy,md,mdAll,mdAll2,mdel,mdis,kdis:Int

	Field wlx,wly,wlb,wlbyte:Int
	Field WordBank:Int[(500000*HasWordList)+5]
	
	Field tx:Int[10]
	Field ty:Int[10]
	Field td:Int[10]
	Field but:Int[20]
	Field DPadX:Int,DPadY:Int,DPadZ:Float

	Field BadgeGet:Int[15]
	Field BadgeTick:Int[15]

	Field scaleX:Float,scaleY:Float

	Field J_Loader,J_WW,J_WH:Int
	Field J_AX#,J_AY#,J_AXU#,J_AYU#,J_AX_Level#,J_AY_Level#
	Field J_Font:Int
	Field J_CLS_R:Float,J_CLS_G:Float,J_CLS_B:Float,J_CLS_A:Float
	Field J_Scale_X:Float,J_Scale_Y:Float,J_Rot:Float
	Field J_R:Float,J_G:Float,J_B:Float,J_A:Float

	Field J_Retina:Int,J_RetinaD:Float
	Field DataBuffer:Int[16384]
	Field DataGrab=0
	Field DataGrabImg=0



#If TARGET="ios"
	Field gamectr:GameCenter
#End


	Method BadgeID$(fn)
		Select fn
			Case 0
				Return "Test Badge|This is a Test Badge which has no purpose."
		End Select
	End
	
' 			Word List
	Method Loader_WordList()
		Cls(0,0,0)
			Local PixelArray:Int[4096]
			Local ba,bb
			SetColor(255,255,255)
			DebugLog "Loading WordList "+wlb
			DrawImage(img[85],32,32,wlb-1)
			wlb=wlb+1
			ReadPixels(PixelArray,0,0,64,64,0,0)
			For y=0 To 63
			For x=0 To 31
				ba=PixelArray[(y*64)+(x*2)]
				bb=PixelArray[(y*64)+(x*2)+1]
				
				v=0
				w=0
				v=((ba & $FF) Shr 0)/8
				w=w+(v Shl 0)
				v=((ba & $FF00) Shr 8)/8
				w=w+(v Shl 5)
				v=((ba & $FF0000) Shr 16)/8
				w=w+(v Shl 10)
				
				v=((bb & $FF) Shr 0)/8
				w=w+(v Shl 15)
				v=((bb & $FF00) Shr 8)/8
				w=w+(v Shl 20)
				v=((bb & $FF0000) Shr 16)/8
				w=w+(v Shl 25)

				WordBank[wlbyte]=w				
				wlbyte=wlbyte+1				
			Next
			Next	
			
		Cls(0,0,0)
	End

	Method CheckWord$(ftxt2$)
		If ftxt2.Length()>12 Or ftxt2.Length()<2 Then Return ""
		Local ftxt$=ftxt2+"                 "
		Local fout$
		Local fn=0
		Local ma=0
		Local mb=0
		Local ca=0
		Local cb=0
		Local wa,wb
		ftxt=ftxt.ToUpper()
		a=64
		
		If ftxt[0]>64 And ftxt[0]<91 Then ma=ma+(31 Shl 0);ca=ca+((ftxt[0]-a) Shl 0)
		If ftxt[1]>64 And ftxt[1]<91 Then ma=ma+(31 Shl 5);ca=ca+((ftxt[1]-a) Shl 5)
		If ftxt[2]>64 And ftxt[2]<91 Then ma=ma+(31 Shl 10);ca=ca+((ftxt[2]-a) Shl 10)
		If ftxt[3]>64 And ftxt[3]<91 Then ma=ma+(31 Shl 15);ca=ca+((ftxt[3]-a) Shl 15)
		If ftxt[4]>64 And ftxt[4]<91 Then ma=ma+(31 Shl 20);ca=ca+((ftxt[4]-a) Shl 20)
		If ftxt[5]>64 And ftxt[5]<91 Then ma=ma+(31 Shl 25);ca=ca+((ftxt[5]-a) Shl 25)
		If ftxt[6]>64 And ftxt[6]<91 Then mb=mb+(31 Shl 0);cb=cb+((ftxt[6]-a) Shl 0)
		If ftxt[7]>64 And ftxt[7]<91 Then mb=mb+(31 Shl 5);cb=cb+((ftxt[7]-a) Shl 5)
		If ftxt[8]>64 And ftxt[8]<91 Then mb=mb+(31 Shl 10);cb=cb+((ftxt[8]-a) Shl 10)
		If ftxt[9]>64 And ftxt[9]<91 Then mb=mb+(31 Shl 15);cb=cb+((ftxt[9]-a) Shl 15)
		If ftxt[10]>64 And ftxt[10]<91 Then mb=mb+(31 Shl 20);cb=cb+((ftxt[10]-a) Shl 20)
		If ftxt[11]>64 And ftxt[11]<91 Then mb=mb+(31 Shl 25);cb=cb+((ftxt[11]-a) Shl 25)
		
		For fn=0 To wlbyte/2
			wa=WordBank[(fn*2)]
			wb=WordBank[(fn*2)+1]
			If (wa & ma)=ca And (wb & mb)=cb 
				fout=GetWord(wa,wb)
				If ftxt2.Length()=fout.Length() Then Return fout
			Endif
		Next
	End

	Method GetWord$(fa,fb=0)
		Local ftxt$=""
		Local derp$=""
		Local fw
		a=64
		fw=((fa Shr 0) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fa Shr 5) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fa Shr 10) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fa Shr 15) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fa Shr 20) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fa Shr 25) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 0) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 5) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 10) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 15) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 20) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		fw=((fb Shr 25) & 31) If fw>0 Then ftxt=ftxt+derp.FromChar(fw+a)
		Return ftxt
	End
	
	
	
	' Main Stuff
	
	Method Loader()
		J_Retina=1;J_RetinaD=1;		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25

		'DebugLog(J_Loader)
			Select J_Loader
			' Default Images/Icons
				Case 1
					LoadImg(97,"common/icons",32,32,16,Image.MidHandle)
					If HasWordList=1
						LoadImgRaw(85,"common/WordList",64,64,256,Image.MidHandle)
						wlx=0;wly=0;wlb=1;wlbyte=0
					Endif
				Case 2
					LoadImg(95,"common/Buttons",64,64,16,Image.MidHandle)
				Case 3
					LoadImg(94,"common/dpad",32,32,16,Image.MidHandle)
				Case 4
					LoadImg(92,"common/icade",64,64,2,Image.MidHandle)
				Case 5
					LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)

			' Default Font	
				Case 6
					LoadFont(90,"fonts/editundo",7,10)
					

								
			' Default SFX
				Case 7
					LoadSFX(1)
				Case 8
					LoadSFX(95)
				Case 9
					LoadSFX(98)	
				Case 10
					LoadSFX(99)
				
			' Menu and Logo
				Case 11
					LoadImg(99,"menu",256,256,4,Image.MidHandle)
				Case 12
					LoadImg(98,"logo",256,128,1,Image.MidHandle)
				Case 13
					LoadImg(96,"parts",8,8,16,Image.MidHandle)
				Case 14
					LoadImg(80,"BadgesA",64,64,64,Image.MidHandle)

			' Your stuff
								
				Default
					J_Loader=0
			End Select
			
		If J_Loader>0 Then J_Loader=J_Loader+1
		WaitStart(1)
	End

	
	Method Reload()
		J_CLS_R=0;J_CLS_G=0;J_CLS_B=0;J_CLS_A=1;
		J_Retina=1;J_RetinaD=1;
		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25
		LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)
		LoadFont(90,"fonts/editundo",7,10)

		J_Loader=1
	End
	
	
	' Stringy Things
	
	Method MyNth$()
		' Compares Score to Highscores,
		' Places position into n variable
		' Returns "Xth" string.
		Local fout$
		n=0
		For m=0 To 9
		If Score>=High[((GameType-1)*MaxHigh)+m] And n=0 Then n=m+1
		Next
		Select n
			Case 1 fout="1st!"
			Case 2 fout="2nd"
			Case 3 fout="3rd"
			Case 4 fout="4th"
			Case 5 fout="5th"
			Case 6 fout="6th"
			Case 7 fout="7th"
			Case 8 fout="8th"
			Case 9 fout="9th"
			Case 10 fout="10th"
		End Select
		Return fout
	End
	
	Method GetFlag(fn,ff)
		Return ((fn Shr (ff-1)) & 1)
	End
	Method SetFlag(fn,ff,ft)
		If ft=0
			Return fn & ($FFFFFFFF-(1 Shl (ff-1)))
		Endif
		If ft=1
			Return fn | (1 Shl (ff-1))
		Endif
	End

	Method Rand(fa#,fb#)
		Return Floor(Rnd(fa,fb+0.99))
	End 
	
	Method rstr$(fn,fd=8,ftxt$=" ")
		' Right align a number (fn),
		' with fd characters in the returned string.
		' padded using ftxt$
		  ' eg rstr$(123,8,"0") = "00000123"
		  '    rstr$(123,9," ") = "      123"
		 
		Local fout$=ftxt
		For n=1 To fd
		fout=fout+ftxt
		Next
		
		fout=fout+fn
		Return fout[-fd..]
	End
	
	Method JNKrunch$(ftxt$)
	Local fout$=""
	Local ftxt2$=""
	
		p=0
		s=1
		v=ftxt[0]
		
		For n=1 To ftxt.Length()-1
			i=ftxt[n]
			u=s;If s>26 Then u=u+6
			If i=v
				s=s+1
				If s>52
					ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
					ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
					s=1;v=i;p=p+1
					If p=10 Then fout=fout+" ";p=0					
				Endif
			Endif
			
			If i<>v
				ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
				ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
				s=1;v=i;p=p+1
				If p=10 Then fout=fout+" ";p=0					
			Endif			
		Next

		u=s;If s>26 Then u=u+6
		ftxt2=ftxt2.FromChar(u+64);fout=fout+ftxt2
		ftxt2=ftxt2.FromChar(v);fout=fout+ftxt2
	
	Return fout					
	End
	
	Method JuNKrunch$(ftxt$)
	Local fout$=""
	Local ftxt2$=""
	
		n=0
		f=0
		Repeat
			d=0
			c=ftxt[n]
			s=c-64
			If c>90 Then s=c-70
			If c<65 Or c>122 Then d=1
			
			If d=0
				n=n+1
				ftxt2=ftxt2.FromChar(ftxt[n])
				For m=1 To s
					fout=fout+ftxt2
				Next
			Endif
			n=n+1
			If n>=ftxt.Length() Then f=1
		Until f=1
	
	Return fout
	End
	
	
	' Loading
	
	Method LoadImg(fi,file$,width,height,frames,flags)
		If J_Retina=2 Then file=file+"-hd"
		If J_Retina=4 Then file=file+"-hd2"
		file=file+".png"
		img[fi]=Null;
		img[fi]=LoadImage(file,width*J_Retina,height*J_Retina,frames,flags)
		imgd[fi*3]=width*J_Retina
		imgd[fi*3+1]=height*J_Retina
		imgd[fi*3+2]=frames
	End

	Method LoadImgRaw(fi,file$,width,height,frames,flags)
		file=file+".png"
		img[fi]=Null;
		img[fi]=LoadImage(file,width,height,frames,flags)
		imgd[fi*3]=width
		imgd[fi*3+1]=height
		imgd[fi*3+2]=frames
	End


	
	Method LoadFont(fi,file$,fw,fh)		
		If J_Retina=2 Then file=file+"-hd"
		If J_Retina=4 Then file=file+"-hd2"
		file=file+".png"
		img[fi]=LoadImage(file,16*J_Retina,16*J_Retina,128,Image.MidHandle)
		imgd[fi*3]=fw'*J_Retina
		imgd[fi*3+1]=fh'*J_Retina
		imgd[fi*3+2]=128		
		J_Font=fi
	End

	Method OnCreate()
		GameMode=1;
		SetUpdateRate 60
		J_WW=DeviceWidth();J_WH=DeviceHeight()

#If TARGET="ios"
		gamectr=GameCenter.GetGameCenter()
		gamectr.StartGameCenter
#End
#If TARGET="html5"
	HasMusic=0
#End

		If HasMusic=1 Then MusicPlayer.JM_Init( MaxChannels,4,3,3,4)

		J_AX_Level=0;J_AY_Level=0;
		
#If TARGET="html5" Or TARGET="flash"
		J_CLS_R=0;J_CLS_G=0;J_CLS_B=0;J_CLS_A=1;
		J_Retina=1;J_RetinaD=1;		
		If DeviceWidth()>630 Or DeviceHeight()>630 Then J_Retina=2;J_RetinaD=0.5
		If DeviceWidth()>1230 Or DeviceHeight()>1230 Then J_Retina=4;J_RetinaD=0.25

		LoadImg(93,"common/AGAWLogo",256,256,1,Image.MidHandle)
		LoadFont(90,"fonts/editundo",7,10)

		SetUpdateRate 6
		GameMode=5
#Else
		Reload()
#End
	
		GameType=2
		MenuIn=-32
		ToSprites=50
		Paused=0;PausedMove=-1;PausedIn=-64
		
		For n=0 To 14
			BadgeGet[n]=0;BadgeTick[n]=0;
		Next
		For n=0 To 127
			Badge[n]=False
		Next
		
		For n=0 To 19
			but[n]=0
		Next
		
		For n=0 To 24
			Set[n]=0
		Next
		Set[5]=1
		
		For n=0 To MaxGames*MaxHigh
			High[n]=0
		Next
		
		Load()
		
		For n=0 To MaxChannels
			chan[n]=n
		Next
	End
	
	Method GetData(fimg,fframe)
		DataGrab=fframe;DataGrabImg=fimg
	End
	Method GrabImageData(fimg,fframe)
	DebugLog("Loading Image Data "+fimg+":"+fframe)
				Cls(1,0,0)
				SetAlpha(1)
				SetColor(1,0,0)
				DrawRect(0,0,64,64)
				SetColor(255,255,255)
				DrawImage(img[fimg],0,0,fframe-1)
				Local ba,x,y,argb
				Local PixelArray:Int[4096]
				ReadPixels(PixelArray,0,0,64,64,0,0)
				
				For x=0 To 63
				For y=0 To 63
					argb=PixelArray[y*64+x]
					r=((argb & $FF0000) Shr 16)/8
					g=((argb & $FF00) Shr 8)/8
					b=((argb & $FF))/8
					DataBuffer[((y*64+x)*4)]=r
					DataBuffer[((y*64+x)*4)+1]=g
					DataBuffer[((y*64+x)*4)+2]=b
				Next
				Next
				Cls(1,0,0)
	End

	Method OnRender()
		If HasWordList=1 And wlb>0 And wlb<162 Then Loader_WordList();Loader_WordList()
		If HasMusic=1 Then MusicPlayer.JM_Alive_R()
		If DataGrab>0 Then GrabImageData(DataGrabImg,DataGrab);DataGrab=0;DataGrabImg=0
		
		If (Millisecs()-lmsr)>0 Then fpsr=1000/(Millisecs()-lmsr)
		fpsra=((fpsra*9)+fpsr)/10
		lmsr=Millisecs()
		
		SetColor(J_CLS_R,J_CLS_G,J_CLS_B)
		SetAlpha(J_CLS_A)
		DrawRect(-1,-1,DeviceWidth()+2,DeviceHeight()+2)
		SetColor(255,255,255)
		SetAlpha(1)
		
		If J_WW<>DeviceWidth() Or J_WH<>DeviceHeight()
			J_Loader=1
			J_WW=DeviceWidth();J_WH=DeviceHeight()
		Endif
		
		scaleX=DeviceWidth()/rawscrw
		scaleY=DeviceHeight()/rawscrh
		r=1
		If Abs(scaleY-1)<Abs(scaleX-1) Then r=2
		If scaleX>scaleY Then r=1
		If scaleY>scaleX Then r=2
		
		If r=2 Then scaleX=scaleY;jscrw=DeviceWidth()/scaleX;jscrh=DeviceHeight()/scaleX
		If r=1 Then scaleY=scaleX;jscrw=DeviceWidth()/scaleX;jscrh=DeviceHeight()/scaleX
		
		Orientation=1;If jscrh>jscrw Then Orientation=0
		
		If sprtup>0
			For n=0 To sprtup-15 Step 15
				SetAlpha(sprt[n+7])
				SetColor(sprt[n+10],sprt[n+11],sprt[n+12])
				Select sprt[n]
				Case -3717
					DrawRect(sprt[n+1]*scaleX,sprt[n+2]*scaleY,sprt[n+4]*scaleX,sprt[n+5]*scaleY)
				Case -3716
					DrawEllipse(sprt[n+1]*scaleX,sprt[n+2]*scaleY,sprt[n+4]*scaleX,sprt[n+5]*scaleY)
				Case -3715
					DrawLine(sprt[n+1]*scaleX,sprt[n+2]*scaleY,sprt[n+4]*scaleX,sprt[n+5]*scaleY)

				Default
					If sprt[n]>-1
'#If TARGET="html5"
'						SetColor(255,255,255)
'#End
						If img[sprt[n]]<>Null Then DrawImage(img[sprt[n]],sprt[n+1]*scaleX,sprt[n+2]*scaleY,sprt[n+3],(sprt[n+4]*scaleX)*J_RetinaD,(sprt[n+5]*scaleY)*J_RetinaD,sprt[n+6])
					Endif
				End Select
			Next
		End

			
		SetAlpha(0.5)
		SetColor(255,255,255)	
	End
	
	' ******** Sonic

	Method LoadSFX(fs)
		If fs<10 Then sfx[fs]=LoadSound("sfx/00"+fs+".wav")
		If fs>9 And fs<100 Then sfx[fs]=LoadSound("sfx/0"+fs+".wav")
		If fs>99 Then sfx[fs]=LoadSound("sfx/"+fs+".wav")
	End

	Method PlaySFX(fs,fpitch#=1,fvol#=1,fpan#=0)
		If Set[5]=1 Or Set[5]=2
			If MaxChannels>8 Then LChan=(LChan+1) Mod (MaxChannels-8)
			If MaxChannels<9 Then LChan=(LChan+1) Mod (MaxChannels)
			If LChan<0 Then LChan=0
			If LChan>MaxChannels-1 Then LChan=0
			
			StopChannel(chan[LChan])
			PlaySound(sfx[fs],chan[LChan],0)
			SetChannelRate(chan[LChan],fpitch)
			SetChannelVolume(chan[LChan],fvol)
			SetChannelPan(chan[LChan],fpan)
		Endif
	End
	
	
	' **************   Artsy Fartsy
	
	Method ResetDraw()
		J_Scale_X=1;J_Scale_Y=1;
		J_Rot=0;
		J_R=255;J_G=255;J_B=255;J_A=1;
	End

	Method SetCol(fr#,fg#,fb#,fa#=-3717)
		J_R=fr;J_G=fg;J_B=fb
		If fa>-3717 Then J_A=fa
	End
	
	Method SetRot(fr#)
		J_Rot=-fr
	End
	Method Alpha(fa#)
		J_A=fa
	End
	
	Method SetSize(fx:Float,fy#=-3717)
		J_Scale_X=fx;J_Scale_Y=fx
		If fy>-3717 Then J_Scale_Y=fy
	End
	
	
	Method CLS2D(fr#=-3717,fg#=-1,fb#=-1,fa#=-1)
		If fr>-3717
			J_CLS_R=fr
			J_CLS_G=fg
			J_CLS_B=fb
			J_CLS_A=fa
		Endif
		ResetDraw();
		'Cls()
		sprtup=0
	End

	Method Text(fx#,fy#,ftxt$,fc#=0,fcy#=0)
	Local fn,fl,fv:Int
	fcy=fcy-1
	fx=fx+( (Sin((-J_Rot)-90)*(imgd[J_Font*3]*J_Scale_X*(ftxt.Length-1))) *(fc/2))
	fy=fy-( (Cos((-J_Rot)-90)*(imgd[J_Font*3]*J_Scale_X*(ftxt.Length-1))) *(fc/2))
	fx=fx+( (Sin((-J_Rot))*(imgd[J_Font*3+1]*J_Scale_Y)) *(fcy/2))
	fy=fy-( (Cos((-J_Rot))*(imgd[J_Font*3+1]*J_Scale_Y)) *(fcy/2))

	Local fsx#=fx
	Local fsy#=fy

#If TARGET="html5"
	J_R=255;J_G=255;J_B=255
#End

		For fn=0 To ftxt.Length-1
			
			fv=ftxt[fn]-32
			If ftxt[fn]=92 And ftxt[fn+1]=110
				fn=fn+1;fv=-32;fl=fl+1
				fx=fsx+(Sin((-J_Rot)+180)*(imgd[J_Font*3+1]*J_Scale_Y*fl))
				fy=fsy-(Cos((-J_Rot)+180)*(imgd[J_Font*3+1]*J_Scale_Y*fl))
			Endif
			If fv>0 And fv<128 Then DrawImg(J_Font,fx,fy,fv)
			If fv>-32
				fx=fx+(Sin((-J_Rot)+90)*(imgd[J_Font*3]*J_Scale_X))
				fy=fy-(Cos((-J_Rot)+90)*(imgd[J_Font*3]*J_Scale_X))
			Endif
		Next
		
	End

		
	Method DrawImg(fi,fx#,fy#,ff#=0)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=fi;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=ff
			sprt[sprtup+4]=J_Scale_X;sprt[sprtup+5]=J_Scale_Y;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B
'#If TARGET="html5"
'			sprt[sprtup+10]=255;sprt[sprtup+11]=255;sprt[sprtup+12]=255	
'#End
			sprtup=sprtup+15
		Endif
	End
	
	Method Rect(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3717;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B			
			sprtup=sprtup+15
		Endif		
	End
	Method Oval(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3716;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B			
			sprtup=sprtup+15
		Endif		
	End
	Method Line(fx#,fy#,fw#,fh#)
		If sprtup<(MaxSprites-1)*15
			sprt[sprtup]=-3715;sprt[sprtup+1]=fx;sprt[sprtup+2]=fy;sprt[sprtup+6]=0
			sprt[sprtup+4]=fw;sprt[sprtup+5]=fh;sprt[sprtup+3]=J_Rot
			sprt[sprtup+7]=J_A
			sprt[sprtup+10]=J_R;sprt[sprtup+11]=J_G;sprt[sprtup+12]=J_B			
			sprtup=sprtup+15
		Endif		
	End
	
	Method Button(fi,fx#,fy#,ff)
		DrawImg(fi,fx,fy,ff)
		o=0
		For n=0 To 9
		If (tx[n]>fx-((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And tx[n]<fx+((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And ty[n]>fy-((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And ty[n]<fy+((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And mdAll>0)
			o=1
		End
		Next
		Return o
	End
	Method Button0(fi,fx#,fy#,ff)
		DrawImg(fi,fx,fy,ff)
		n=0
		If (tx[n]>fx-((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And tx[n]<fx+((imgd[fi*3]*J_RetinaD)*J_Scale_X*.5) And ty[n]>fy-((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And ty[n]<fy+((imgd[fi*3+1]*J_RetinaD)*J_Scale_Y*.5) And mdAll>0)
			Return 1
		End
		Return 0
	End
	
	' ***********  Load/Save
	
	Method Save()
		Local out$=""
		Local sum=0
		' Settings
		For n=0 To 24
			out=out+Set[n]+"|"
			sum=sum+Set[n]*n
		Next
		out=out+sum+"|";sum=0
		
		' Badges
		For w=0 To 7
		v=0
		For b=0 To 31
			v=v+(Badge[w*32+b] Shl b)
		Next
		out=out+v+"|"
		sum=sum+v
		Next
		out=out+sum+"|";sum=0
		
		' Highscores
		For g=0 To MaxGames-1
		For h=0 To MaxHigh-1
			out=out+High[(g*MaxHigh)+h]+"|"
			sum=sum+(High[(g*MaxHigh)+(h)]*(h+4))
			out=out+High[(g*MaxHigh)+h+(MaxGames*MaxHigh)]+"|"
			sum=sum+(High[(g*MaxHigh)+h+(MaxGames*MaxHigh)]*(g+h+3))
		Next
		out=out+sum+"|";sum=0
		Next
		
		If DebugMode=1 Then DebugLog(out)
		
		SaveState(out)
	End
	
	Method Load()
		Local out$=LoadState()
		Local sum=0
		Local bits:=out.Split("|")
		c=0
		
		If DebugMode=1 Then DebugLog(out)
		
		' Settings
		If bits.Length>24
			For n=0 To 24
'				DebugLog(bits[n])
				Set[n]=Int(bits[n])
				sum=sum+Set[n]*n
			Next
			c=c+25
			v=Int(bits[c]);c=c+1
			If sum=v Then DebugLog("Settings Loaded")
			If sum<>v
				DebugLog("Settings Checksum Invalid")
				For n=0 To 24
					Set[n]=0
				Next
				Set[5]=1
			Endif
			v=0;sum=0
		Endif
		
		
		If Set[10]<64 Then Set[10]=64
		If Set[11]<64 Then Set[11]=64
		If Set[12]<8 Then Set[12]=10
		
		
		If bits.Length>c+8
			' Badges
			sum=0
			For w=0 To 7
				v=Int(bits[c+w])
				For b=0 To 31
					Badge[w*32+b]=Bool((v Shr b) & 1)
'					v=v+(Badge[w*32+b] Shl b)
				Next
				sum=sum+v
			Next
			c=c+8;
			v=Int(bits[c]);c=c+1
			If sum=v Then DebugLog("Badges Loaded")
			If sum<>v
				DebugLog("Badge Checksum Invalid")
				For b=0 To 255
					Badge[b]=False
				Next
			Endif
		Endif
		
		For g=0 To MaxGames-1
			If bits.Length>c+20
				sum=0
				For h=0 To MaxHigh-1
					High[(g*MaxHigh)+h]=Int(bits[c+(h*2)])
					sum=sum+(High[(g*MaxHigh)+h]*(h+4))
					High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]=Int(bits[c+(h*2)+1])
					sum=sum+(High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]*(g+h+3))					
				Next
				c=c+MaxHigh*2
				v=Int(bits[c]);c=c+1
				If sum=v Then DebugLog("Highscore "+g+" Loaded")
				If sum<>v
					DebugLog("Highscore "+g+" Checksum Invalid")
					For h=0 To MaxHigh-1
						High[(g*MaxHigh)+h]=0
						High[(g*MaxHigh)+h+(MaxHigh*MaxGames)]=0
					Next
				Endif
			Endif
		Next
	End
	
	
	' ******* BADGES!!
	
	Method BadgeName$(fn)
		Local out$=BadgeID(fn)
		Local bits:=out.Split("|")
		Return bits[0]
	End	
	Method BadgeDetail$(fn)
		Local out$=BadgeID(fn)
		Local bits:=out.Split("|")
		Return bits[1]
	End	
	
	
	Method GiveBadge(fn)
		If Badge[fn]=False
			Badge[fn]=True
			PlaySFX(95)
			f=0
			For b=0 To 12
				If BadgeTick[b]=0 And f=0 Then f=1;BadgeTick[b]=1;BadgeGet[b]=fn
			Next
		Endif
	End
	
	Method ShowBadges()
	ResetDraw()
	w=160
		For b=0 To 12
			If BadgeTick[b]>0
				BadgeTick[b]=BadgeTick[b]+1
				x=(-w)+BadgeTick[b]*16
				If BadgeTick[b]>240-(w/16) Then x=(-w)+((240-BadgeTick[b])*16)
				If x>0 Then x=0
						
				If BadgeTick[b]>240 Then BadgeTick[b]=0
				SetCol(0,0,80,0.8)
				Rect(x,jscrh-((b+1)*34),160,32)

				SetCol(255,255,255,1)
				Text(x+16,jscrh-((b+1)*34)+4,BadgeName(BadgeGet[b]),0,0)
				If BadgeGet[b]<64
					SetSize(0.5)
					DrawImg(80,x+(w-16),jscrh-((b+1)*34)+16,BadgeGet[b])
					SetSize(1)
				Endif
			Endif
		Next
	End
	
	' ******   GameCenter
	Method GC_Scoreboard(fn)
#If TARGET="ios"
		Paused=1
		If gamectr.GameCenterState()=2
			gamectr.ShowLeaderboard(LeaderBoard_ID+rstr(fn,2,"0"))
		Endif
#End
	End
	
	Method GC_PostScore(fn,fs)
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			gamectr.ReportScore(fs,LeaderBoard_ID+rstr(fn,2,"0"))
		Endif
#End
	End
	
	Method GC_Badges()
	Local fn:Int;
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			For fn=0 To 255
				If Badge[fn]=True And BadgeSent[fn]=False
					BadgeSent[fn]=True
					GC_PostBadge(fn,100)
				Endif
			Next
		Endif
#End
	End
	
	Method GC_PostBadge(fn,fp)
#If TARGET="ios"
		If gamectr.GameCenterState()=2
			gamectr.ReportAchievement((fp+1),Badge_ID+rstr(fn,3,"0") )
		Endif
#End
	End
	
	' ******   Core
	Method OnSuspend()
		iCade(0)
		If GameMode<10
			Paused=0;PausedMove=0;PausedIn=0
		Endif
		If GameMode>9	
			Paused=1
			PausedMove=1
			PausedIn=jscrh/2
		Endif
		SetUpdateRate 5
		Save()
	End

	Method OnResume()
		If GameMode<10
			Paused=0;PausedMove=0;PausedIn=0
		Endif
		If GameMode>9	
			Paused=1
			PausedMove=1
			PausedIn=jscrh/2
		Endif
		SetUpdateRate 60
		iCade(0)
		
#If TARGET="ios"
		gamectr=GameCenter.GetGameCenter()
		gamectr.StartGameCenter
#End

	End
	
	Method Touch(fx#,fy#,fw#,fh#)
		Rect(fx,fy,fw,fh)
		Local fo=0
		For n=0 To 9
			If td[n]
				If tx[n]>fx And ty[n]>fy And tx[n]<fx+fw And ty[n]<fy+fh Then fo=1
			Endif
		Next
		Return fo
	End

	Method MouseIn(fx#,fy#,fw#,fh#)
		Local fo=0
		For n=0 To 9
			If td[n]
				If tx[n]>fx And ty[n]>fy And tx[n]<fx+fw And ty[n]<fy+fh Then fo=1
			Endif
		Next
		Return fo
	End

	Method MouseIn_Centered(fx#,fy#,fw#,fh#)
		Local fo=0
		For n=0 To 9
			If td[n]
				If tx[n]>fx-(fw*0.5) And ty[n]>fy-(fh*0.5) And tx[n]<fx+(fw*0.5) And ty[n]<fy+(fh*0.5) Then fo=1
			Endif
		Next
		Return fo
	End



	Method iCade(fn)
		If fn=1
			EnableKeyboard()
			iCadeControls=1
			Repeat
				a=GetChar()
			Until a=0
		Endif
		If fn=0
			DisableKeyboard()
			iCadeControls=0
			For n=0 To 19
				but[n]=0
			Next
		Endif
	End
	
	
	Method PlayKey(fn)
	If iCadeControls=0
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or KeyDown(KEY_W) Or KeyDown(KEY_JOY0_UP) Or (JoyY(0,0)<-0.4) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or KeyDown(KEY_A) Or KeyDown(KEY_JOY0_LEFT) Or (JoyX(0,0)<-0.4) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or KeyDown(KEY_D) Or KeyDown(KEY_JOY0_RIGHT) Or (JoyX(0,0)>0.4) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or KeyDown(KEY_S) Or KeyDown(KEY_JOY0_DOWN) Or (JoyY(0,0)>0.4) Or but[8]
			Case 10
				Return KeyDown(KEY_Z) Or KeyDown(KEY_J) Or KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER)  Or KeyDown(KEY_JOY0_A) Or but[10]
			Case 11
				Return KeyDown(KEY_X) Or KeyDown(KEY_K) Or KeyDown(KEY_CONTROL) Or KeyDown(KEY_JOY0_B) Or but[11]
			Case 12
				Return KeyDown(KEY_C) Or KeyDown(KEY_L) Or KeyDown(KEY_SHIFT) Or KeyDown(KEY_JOY0_X) Or but[12]
			Case 13
				Return KeyDown(KEY_V) Or KeyDown(KEY_I) Or KeyDown(KEY_JOY0_Y) Or but[13]

			Case 99
				Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or JoyDown(JOY_START,0) Or but[16] Or but[17]
		End
	End
	
	If iCadeControls=1
		Select fn
			Case 0
				Return KeyDown(KEY_UP) Or KeyDown(KEY_JOY0_UP) Or (JoyY(0,0)<-0.4) Or but[0]
			Case 3
				Return KeyDown(KEY_LEFT) Or KeyDown(KEY_JOY0_LEFT) Or (JoyX(0,0)<-0.4) Or but[3]
			Case 5
				Return KeyDown(KEY_RIGHT) Or KeyDown(KEY_JOY0_RIGHT) Or (JoyX(0,0)>0.4) Or but[5]
			Case 8
				Return KeyDown(KEY_DOWN) Or KeyDown(KEY_JOY0_DOWN) Or (JoyY(0,0)>0.4) Or but[8]
			Case 10
				Return KeyDown(KEY_SPACE) Or KeyDown(KEY_ENTER)  Or KeyDown(KEY_JOY0_A) Or but[10]
			Case 11
				Return KeyDown(KEY_CONTROL) Or KeyDown(KEY_JOY0_B) Or but[11]
			Case 12
				Return KeyDown(KEY_SHIFT) Or KeyDown(KEY_JOY0_X) Or but[12]
			Case 13
				Return KeyDown(KEY_JOY0_Y) Or but[13]

			Case 99
				Return KeyDown(KEY_ESCAPE) Or KeyDown(KEY_DELETE) Or KeyDown(KEY_BACKSPACE) Or JoyDown(JOY_START,0) Or but[16] Or but[17]
		End
		
	End
	
	End


	Method PauseMenu()
		
		ResetDraw()
		SetCol(0,0,0,((Abs(PausedIn))/(jscrh*.8)))
		Rect(0,0,jscrw,jscrh)
		
		If PausedMove=1 And PausedIn<jscrh/2 Then PausedIn=PausedIn+24
		If PausedMove=-1 And PausedIn>-64 Then PausedIn=PausedIn-24
		If PausedMove=-1 And PausedIn<-32 Then Paused=0
		ResetDraw()
		
		If Orientation=1	'1=Landscape
			SetCol(255,255,10,0.6)
			Rect(jscrw/2-128,PausedIn-64,256,8)
			SetCol(255,150,10,0.7)
			Rect(jscrw/2-140,PausedIn-52,280,104)
			SetCol(10,150,255,0.6)
			Rect(jscrw/2-128,PausedIn+56,256,8)
		Endif
		
		If Orientation=0 	'0=Portrait
			SetCol(255,255,10,0.6)
			Rect(jscrw/2-96,PausedIn-92,192,8)
			SetCol(255,150,10,0.7)
			Rect(jscrw/2-128,PausedIn-80,256,160)
			SetCol(10,150,255,0.6)
			Rect(jscrw/2-96,PausedIn+84,192,8)
		Endif
		
				
		' ** Play
		SetSize(2)
		SetCol(50,50,250,1)
		If Button(97,jscrw/2,PausedIn,3) And mdis=0
			Paused=1;PausedMove=-1;mdis=1;PlaySFX(98,1,0.5)
		Endif
		If PausedMenu=0
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,jscrw/2,PausedIn,6)
			If PlayKey(10) And kdis=0 Then Paused=1;PausedMove=-1;kdis=1;PlaySFX(98,1,0.5)
			If (PlayKey(3) Or PlayKey(0)) And kdis=0 Then PausedMenu=-1;kdis=1;PlaySFX(98,0.8,0.5)
			If (PlayKey(5)) And kdis=0 Then PausedMenu=1;kdis=1	;PlaySFX(98,1.2,0.5)
		Endif
		
		SetSize(2)
		' ** Quit
		SetCol(255,50,50,1)
		x=jscrw/2-140;y=PausedIn-64
		If Orientation=0 Then x=jscrw/2-96;y=PausedIn-96
		If Button(97,x,y,1) And mdis=0
			Paused=0;PausedMove=-1;PausedIn=-64;EndofGame=1;mdis=1;PlaySFX(98,0.5,0.5)
		Endif
		If PausedMenu=-1
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,x,y,6)
			If PlayKey(10) And kdis=0 Then Paused=0;PausedMove=-1;PausedIn=-64;EndofGame=1;mdis=1;kdis=1;PlaySFX(98,0.5,0.5)
			If (PlayKey(5) Or PlayKey(8)) And kdis=0 Then PausedMenu=0;kdis=1;PlaySFX(98,0.8,0.5)
		Endif
		
		' ** Sound
		SetSize(2)
		SetCol(50,250,50,1)
		s=4;If Set[5]=0 Then s=5
		x=jscrw/2+140;y=PausedIn-64
		If Orientation=0 Then x=jscrw/2+96;y=PausedIn-96
		If Button(97,x,y,s) And mdis=0
			If HasMusic=1 Then Set[5]=(Set[5]+1) Mod 4;
			If HasMusic=0
				Set[5]=1-Set[5]
				If Set[5]<0 Or Set[5]>1 Then Set[5]=0
			Endif
			mdis=1;PlaySFX(98,1,0.5)
		Endif
		If Set[5]>0 And Set[5]<4 And HasMusic=1
			SetSize(1.5)
			SetCol(180,255,255,1)
			DrawImg(97,x+20,y,Set[5]+7)
		Endif
		If PausedMenu=1
			SetSize(2.5)
			SetCol(255,255,100,1)
			DrawImg(97,x,y,6)
			If PlayKey(10) And kdis=0 Then Set[5]=(Set[5]+1) Mod 4;kdis=1;PlaySFX(98,1,0.5)
			If (PlayKey(3) Or PlayKey(8)) And kdis=0 Then PausedMenu=0;kdis=1;PlaySFX(98,0.8,0.5)
		Endif

		If PlayKey(99) And kdis=0 Then kdis=1;Paused=1;PausedMove=-1;PlaySFX(98,1,0.5)
	End
	

	Method InGame()
		ResetDraw()
		MenuIn=-32
		
		If PlayKey(99) And Paused=0 And kdis=0 Then kdis=1; Paused=1;PausedMove=1;PausedMenu=0;;PlaySFX(98,1,0.5)
		
		If Button(97,16,16,0) And mdis=0 And Paused=0
			Paused=1;PausedMove=1;mdis=1;PausedMenu=0;PlaySFX(98,1,0.5)
		Endif
		If Paused=1 Then PauseMenu()
	End
	
	
	Method WaitStart(fn=0)
		CLS2D(40,40,80,1)
		u=jscrw
		If jscrh<jscrw Then u=jscrh
		wr=wr+16
If fn=1
		For n=0 To 10
			SetCol(250,250,250,Float(n)/10)
			Oval((jscrw*.5)+(Sin((wr+180)+(n*16))*u*.25),(jscrh*.5)-(Cos((wr+180)+(n*16))*u*.25),8,8)
		Next
Endif

		SetCol(255,255,0,0.8)
		Oval(jscrw*.5,jscrh*.5,u*.3,u*.3)
		SetCol(250,160,60,0.7)
		Rect(0,jscrh*.4,jscrw,jscrh*.2)

		ResetDraw();
		DrawImg(93,jscrw*.5,jscrh*.48,0)
If fn=1
		For n=0 To 10
			SetCol(50,50,50,Float(n)/10)
			Oval((jscrw*.5)+(Sin(wr+(n*16))*u*.25),(jscrh*.5)-(Cos(wr+(n*16))*u*.25),8,8)
		Next
Endif

If fn=0
SetSize(1)
	SetCol(0,0,0,0.2)
	Oval(jscrw*0.5,jscrh*0.7,128+8,16+8)
	Oval(jscrw*0.5,jscrh*0.7,128+4,16+4)
	Oval(jscrw*0.5,jscrh*0.7,128,16)
	
SetSize(2)
	SetCol(255,255,255,1)
	Text(jscrw*0.5,jscrh*0.7," Click to Start",1,0.8)	
Endif
		If fn=0 And (mdAll2>0) And mx>jscrw*.25 And my>jscrh*.25 And mx<jscrw*.75 And my<jscrh*.75
			mdis=1
			GameMode=1
			Reload()
			SetUpdateRate 60
		Endif
	End

	Method OnUpdate()
		If (Millisecs()-lmsu)>0 Then fpsu=1000/(Millisecs()-lmsu)
		fpsua=((fpsua*9)+fpsu)/10
		lmsu=Millisecs()

		If HasMusic=1 Then MusicPlayer.JM_Alive_U(Paused,(Set[5]=1 Or Set[5]=3))

		mwx=mx;mwy=my
		mx=MouseX()/scaleX
		my=MouseY()/scaleY
		If md=0 And MouseDown() Then mwx=mx;mwy=my
		mdAll=MouseDown()
		mdAll2=MouseHit()
		For n=0 To 9
			td[n]=0;tx[n]=-3717;ty[n]=-3717
			If TouchDown(n)
				td[n]=1;tx[n]=TouchX(n)/scaleX;ty[n]=TouchY(n)/scaleY
				mdAll=1
			Endif
		Next
		
		md=MouseDown()
		If mdAll=0 Then mdis=0
		If mdel>0 Then mdel=mdel-1

		If Not PlayKey(0) And Not PlayKey(3) And Not PlayKey(5) And Not PlayKey(8) And Not PlayKey(10) And Not PlayKey(11) And Not PlayKey(12) And Not PlayKey(13) And Not PlayKey(14) And Not PlayKey(15) And Not PlayKey(16) And Not PlayKey(17) And Not PlayKey(99) Then kdis=0
	If kdis=0 And mdis=0 And PlayKey(99) And GameMode=1
		If CreditsOn=1 Or BadgesOn=1 Then CreditsOn=0;BadgesOn=0;kdis=1;mdis=1
	Endif
	

		If J_Loader=0
		Select GameMode
			Case 1
				Menu()
			Case 2
				LoadMenu()
				GameMode=1
			Case 5
				WaitStart()
			
			Case 10
				Game()
				InGame()
				
			Case 11
				LoadGame()

		End Select
		
	If GameMode=10 And EndofGame>0 Then GameOver()
	If GameMode=1 Or GameMode=2 Then GameOver()
	If GameMode=1 And CreditsOn=1 Then CreditBox()
	If GameMode=1 And BadgesOn=1 Then BadgesBox()
	
		Endif
		
		If J_Loader>0 Then Loader()

#Rem
	iCade
	
	Up		W	E
	Down	X	Z
	Left	A	Q
	Right	D	C
	
	1		Y	T
	2		U	F
	3		I	M
	4		O	G
	5		H	R
	6		J	N
	7		K	P
	8		L	V
#End

If iCadeControls=1
	Repeat
		a=GetChar()
		If a>0
		Select String.FromChar(a)
			Case "W","w"	but[0]=2
			Case "E","e"	but[0]=0

			Case "X","x"	but[8]=2
			Case "Z","z"	but[8]=0

			Case "A","a"	but[3]=2
			Case "Q","q"	but[3]=0

			Case "D","d"	but[5]=2
			Case "C","c"	but[5]=0


			Case "Y","y"	but[13]=2
			Case "T","t"	but[13]=0

			Case "U","u"	but[14]=2
			Case "F","f"	but[14]=0

			Case "I","i"	but[15]=2
			Case "M","m"	but[15]=0

			Case "O","o"	but[16]=2
			Case "G","g"	but[16]=0


			Case "H","h"	but[10]=2
			Case "R","r"	but[10]=0
			
			Case "J","j"	but[11]=2
			Case "N","n"	but[11]=0

			Case "K","k"	but[12]=2
			Case "P","p"	but[12]=0

			Case "L","l"	but[17]=2
			Case "V","v"	but[17]=0
			
		End Select
		Endif
	Until a=0
	
Endif

		For n=0 To 19
			If but[n]=1 Then but[n]=0
		Next

		If OnScreenControls=1 And GameMode>5 And iCadeControls=0
			If Set[10]<32 Then Set[10]=32
			If Set[10]>jscrw-32 Then Set[10]=jscrw-32
			If Set[11]<32 Then Set[11]=32
			If Set[11]>jscrh-32 Then Set[11]=jscrh-32
			If Set[12]<8 Then Set[12]=8
			If Set[12]>25 Then Set[12]=25
		
			DPadX=Set[10]
			DPadY=jscrh-Set[11]
			DPadZ=Float(Set[12])/10
			ResetDraw();SetCol(255,255,255,0.6)
			SetSize(DPadZ)
			If Button(94,(DPadX)-(32*DPadZ),DPadY,4) And Paused=0 Then but[3]=1
			If Button(94,(DPadX),DPadY-(32*DPadZ),1) And Paused=0 Then but[0]=1
			If Button(94,(DPadX),DPadY+(32*DPadZ),9) And Paused=0 Then but[8]=1
			If Button(94,(DPadX)+(32*DPadZ),DPadY,6) And Paused=0 Then but[5]=1
			DrawImg(94,(DPadX),DPadY,5)
			If Paused>0
				SetSize(3)
				If Button0(94,(DPadX),DPadY,0) And td[1]=0
					Set[10]=tx[0]
					Set[11]=jscrh-ty[0]
				Endif
				If td[1]=0 Then e=0;f=0
				If td[0] And td[1]
					d=tx[0]-tx[1]
					If tx[1]<tx[0] Then d=tx[1]-tx[0]
					d=d/16
						If e=1
							Set[12]=Set[12]-(d-f)
						Endif
					f=d
					e=1
				Endif
			Endif

			SetSize(1.5*DPadZ)
			If Button(94,jscrw-((DPadX)-(24*DPadZ)),DPadY-(24*DPadZ),0) Then but[10]=1
			If Button(94,jscrw-((DPadX)+(24*DPadZ)),DPadY+(24*DPadZ),0) Then but[11]=1
		Endif

		If AccelerometerControls=1 And iCadeControls=0
			ResetDraw()
			SetSize(1.5)
			SetCol(255,255,255,0.8)
			J_AX=-(J_AX_Level-AccelX())
			J_AY=-(J_AY_Level-AccelY())
			
			J_AXU=J_AXU-((J_AXU-J_AX)/4)
			J_AYU=J_AYU-((J_AYU-J_AY)/4)
			If Abs(J_AXU-J_AX)<0.005 Then J_AXU=J_AX
			If Abs(J_AYU-J_AY)<0.005 Then J_AYU=J_AY
			
			
			If Button(97,24,jscrh-24,7)
				J_AX_Level=AccelX()
				J_AY_Level=AccelY()
			Endif
						
			SetCol(100,255,100,0.6)
			SetSize(1)
			Oval(24+(J_AXU*20),(jscrh-24)+(J_AYU*20),4,4)
		Endif
			
			If iCadeControls=1 ' disable Accelerometer!
				J_AX=0;J_AXU=0
				J_AY=0;J_AYU=0
			Endif

		If DebugMode=1 And GameMode<>5
			ResetDraw()
			If AccelerometerControls=1 And iCadeControls=0 Then Text 16,jscrh*.5,fpsra+":"+scaleX+","+scaleY
			If AccelerometerControls=0 Or iCadeControls=1 Then Text 16,jscrh-16,fpsra+":"+scaleX+","+scaleY
		Endif
		
		ShowBadges()		
 	End


	Method CreditBox()
		ResetDraw()
		SetCol(255,125,0,0.8)
		Rect(jscrw*0.1,jscrh*0.2,jscrw*0.8,jscrh*0.6)
		SetCol(100,0,0,0.8)
		Rect(jscrw*0.12,jscrh*0.22,jscrw*0.76,jscrh*0.56)
						

		SetCol(255,255,255,1)
		y=0

		SetSize(1.5);If Orientation=0 Then SetSize(1.5)
		Text(jscrw*0.5,jscrh*0.24+y, "A Game By",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y, "Jayenkai",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"AGameAWeek.com",1);y=y+40

		Text(jscrw*0.5,jscrh*0.24+y ,"Created using",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"Monkey",1);y=y+20
		Text(jscrw*0.5,jscrh*0.24+y ,"MonkeyCoder.co.nz",1);y=y+40
		
		If mdAll>0 And mdis=0 Then mdis=1;CreditsOn=0;PlaySFX(99)
	End


	Method BadgesBox()
		ResetDraw()
		SetCol(255,125,0,0.8)
		Rect(jscrw*0.1,-1,jscrw*0.8,jscrh+2)
		SetCol(100,0,0,0.8)
		Rect(jscrw*0.12,-1,jscrw*0.76,jscrh+2)

		SetCol(255,255,255,1)
		y=(BadgesScr)
		q=-1
		If PlayKey(0) Then BadgesAimScr=BadgesAimScr-16
		If PlayKey(8) Then BadgesAimScr=BadgesAimScr+16
		If BadgesAimScr>0 Then BadgesAimScr=0
		
		If md>0 And mx>jscrw*0.12
			d=mwy-my
			BadgesAimScr=BadgesAimScr-d*1.5
		Endif
		
		BadgesScr=BadgesScr-((BadgesScr-BadgesAimScr)/6)
		If Abs(BadgesScr-BadgesAimScr)<6 Then BadgesScr=BadgesAimScr
		
		For b=0 To MaxBadges-1
			If y>-72 And y<jscrh+72
				SetSize(2)
				Alpha(0.5);If Badge[b]=True Then Alpha(1)
				Text(jscrw*0.18,y+16, BadgeName(b));
				If Badge[b]=True
					SetSize(1)
'					Text(jscrw*0.16,y+48,"This is the description of a badge that you've earned")
					If Button(80,jscrw*0.8,y+32,b) Then q=b
				Endif
			Endif
			y=y+72
		Next
			If q>-1
				SetCol(0,40,80,0.7)
				Rect(-1,jscrh*0.5-120,jscrw+2,320)
				SetCol(255,255,255,1)
				SetSize(3);DrawImg(80,jscrw*0.5,jscrh*0.5,q)
				SetSize(1.5)
				Text(jscrw*0.15,jscrh*0.5+120,BadgeDetail(q),0,0)
			Endif
	End

	Method LoadMenu()
		' Organise Scores, Award Highscore, etc..
		g=(GameType-1)*MaxHigh
		u=-1
		
		For n=0 To MaxHigh-1
			If Score>High[g+n] And u=-1 Then u=n
		Next
		
		If u>-1
			For n=MaxHigh-1 To (u+1) Step -1
				High[g+n]=High[g+(n-1)]
			Next
			High[g+u]=Score
		Endif

GC_PostScore(GameType,High[g])
GC_Badges()

		g=g+(MaxGames*MaxHigh)
		
' Last Scores
		For n=MaxHigh-1 To 1 Step -1
			High[g+n]=High[g+(n-1)]
		Next
		High[g]=Score


		Save()
	End

	Method Menu()	
		CLS2D(0,0,80,1)
		If MenuIn<0 Then MenuIn=MenuIn+.25
		
		BarWide=140

#If TARGET="android"
	If kdis=0 And mdis=0 And PlayKey(99) Then Error("")
#End

		ResetDraw()
		SetSize(3)
		DrawImg(99,jscrw/2,jscrh/2+(MenuIn*16),0)
		SetSize(2);Alpha(1)
		DrawImg(99,(jscrw*.4)+(MenuIn*20),jscrh*.5,2)
		SetSize(3);Alpha(1)
		DrawImg(99,jscrw/2,jscrh*.5-(MenuIn*24),1)
		SetSize(1)
		DrawImg(98,jscrw*.4,jscrh*.2+(MenuIn*12),0)
		SetCol(0,0,0,0.4)
		Rect((jscrw-BarWide)-MenuIn*4,0,BarWide,jscrh)
		ResetDraw()
		
				SetSize(2)
		SetCol(50,250,50,1)
		s=4;If Set[5]=0 Then s=5
		x=32+(MenuIn*4);y=jscrh/2
		If Orientation=0 Then x=jscrw/2;y=32+(MenuIn*4)
		If Button(97,x,y,s) And mdis=0
			If HasMusic=1 Then Set[5]=(Set[5]+1) Mod 4;
			If HasMusic=0
				Set[5]=1-Set[5]
				If Set[5]<0 Or Set[5]>1 Then Set[5]=0
			Endif
			mdis=1;PlaySFX(98,1,0.5)
		Endif
		If Set[5]>0 And Set[5]<4 And HasMusic=1
			SetSize(1.5)
			SetCol(180,255,255,1)
			DrawImg(97,x+20,y,Set[5]+7)
		Endif

		
		
		SetCol(255,255,255,0.75)
		SetSize(1)
		If MaxBadges>0
			If Button(95,32,32+(MenuIn*4),14) And mdis=0
				mdis=1;PlaySFX(99)
				BadgesOn=1-BadgesOn
				If BadgesOn=1 Then BadgesScr=0;BadgesAimScr=0
			Endif
		Endif

		SetCol(255,200,100,1)
		SetSize(1.5)
		g=(GameType-1)*MaxHigh
		
		'	Scoreboards
		
		t=(imgd[J_Font*3+1]*J_Scale_Y)
		s=((jscrh-90))-(jscrh/2)
		
		l=Floor(s/t)
		If l<1 Then l=1
		If l>MaxHigh Then l=MaxHigh
		Local ftxto$="Top "+l
		If l=1 Then ftxto="Highscore"
		For m=0 To l-1
			ftxto=ftxto+"\n"+rstr(High[g+m],11)
		Next
		
		If CreditsOn=0 And BadgesOn=0 Then Text(((jscrw-BarWide)-(MenuIn*4))+20,60,ftxto  )
#If TARGET="ios"
	SetCol(255,255,255);SetSize(0.75)
	a=Button(95,(jscrw-32)-(MenuIn*6),jscrh*.5+8,13)
	If a>0 And mdAll>0 And mdis=0
		mdis=1;
		GC_Scoreboard(GameType)
	Endif
	If gamectr.GameCenterState()>2 Then CreditsOn=1	
#End

		SetCol(200,255,100,1)
		SetSize(1.5)
		g=g+(MaxGames*MaxHigh)
		ftxto="Last "+l
		If l=1 Then ftxto="Last"
		For m=0 To l-1
			ftxto=ftxto+"\n"+rstr(High[g+m],11)
		Next

		If CreditsOn=0 And BadgesOn=0 Then Text(((jscrw-BarWide)-(MenuIn*4))+20,jscrh/2+20,ftxto )

		If Orientation=1
						' Menu Buttons - Horizontal (Landscape)
			ResetDraw()
			SetSize(1.5)
			Alpha(1)
			If (Button(95,jscrw*.2,(jscrh*.7)-(MenuIn*8),0) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=1;PlaySFX(98,1,0.5)
			Endif
			If GameType=1 Then Alpha(0.75);DrawImg(95,jscrw*.2,(jscrh*.7)-(MenuIn*8),15)
			
			Alpha(1)
			If (Button(95,jscrw*.4,(jscrh*.7)-(MenuIn*12),1) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=2;PlaySFX(98,1,0.5)
			Endif
			If GameType=2 Then Alpha(0.75);DrawImg(95,jscrw*.4,(jscrh*.7)-(MenuIn*12),15)
			
			Alpha(1)
			If (Button(95,jscrw*.6,(jscrh*.7)-(MenuIn*10),2) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=3;PlaySFX(98,1,0.5)
			Endif
			If GameType=3 Then Alpha(0.75);DrawImg(95,jscrw*.6,(jscrh*.7)-(MenuIn*10),15)
			
			ResetDraw()
		Endif		
		
		If Orientation=0
						' Menu Buttons - Vertical (Portrait)
			ResetDraw()
			SetSize(1.5)
			Alpha(1)
			If (Button(95,jscrw*.3-(MenuIn*8),(jscrh*.45),0) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=1;PlaySFX(98,1,0.5)
			Endif
			If GameType=1 Then Alpha(0.75);DrawImg(95,jscrw*.3-(MenuIn*8),(jscrh*.45),15)

			Alpha(1)
			If (Button(95,jscrw*.3,(jscrh*.65)-(MenuIn*12),1) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=2;PlaySFX(98,1,0.5)
			Endif
			If GameType=2 Then Alpha(0.75);DrawImg(95,jscrw*.3,(jscrh*.65)-(MenuIn*12),15)

			Alpha(1)
			If (Button(95,jscrw*.3+(MenuIn*8),(jscrh*.85),2) And mdis=0) And CreditsOn=0 And BadgesOn=0
				GameMode=11;mdis=1;kdis=1;GameType=3;PlaySFX(98,1,0.5)
			Endif
			If GameType=3 Then Alpha(0.75);DrawImg(95,jscrw*.3+(MenuIn*8),(jscrh*.85),15)

			ResetDraw()
		Endif

		If (PlayKey(0) Or PlayKey(3)) And GameType>1 And kdis=0 And CreditsOn=0 And BadgesOn=0 Then kdis=1;GameType=GameType-1;PlaySFX(98,0.8,0.5)
		If (PlayKey(8) Or PlayKey(5)) And GameType<3 And kdis=0 And CreditsOn=0 And BadgesOn=0 Then kdis=1;GameType=GameType+1;PlaySFX(98,1.2,0.5)
		If (PlayKey(10) Or PlayKey(11) Or PlayKey(12) Or PlayKey(13) Or PlayKey(14) Or PlayKey(15) Or PlayKey(16) Or PlayKey(17)) And kdis=0 And CreditsOn=0 And BadgesOn=0 Then GameMode=11;mdis=1;kdis=1;PlaySFX(98,1,0.5)

		ResetDraw()
		If Button(92,jscrw-38,38+(MenuIn*4),iCadeControls) And CreditsOn=0 And BadgesOn=0
			If mdis=0 And iCadeControls=0 Then mdis=1;iCade(1);PlaySFX(99)
			If mdis=0 And iCadeControls=1 Then mdis=1;iCade(0);PlaySFX(99)
		Endif

		SetSize(0.5)
		If Button(93,(jscrw-70),(jscrh-40)-(MenuIn*4),0) And mdis=0 And CreditsOn=0 And BadgesOn=0
			mdis=1
			PlaySFX(99)
			CreditsOn=1
		Endif	
		
		
		
	End

	Method GameOver()
	If Ending>0
		Local floaty#=Float(Ending)/40
		If floaty>0.7 Then floaty=0.7
		SetCol(0,0,0,floaty)
		Rect(-1,-1,jscrw+2,jscrh+2)
		
		y=Ending*12;If y>jscrh*.45 Then y=jscrh*.45
		ResetDraw()
		SetCol(255,255,0,0.5)
		Rect(-1,(jscrh*.45)-8,y*2,16)
		SetCol(255,128,0,0.5)
		Rect(jscrw-y*2,jscrh*0.55-8,(y*2)+1,16)
		
		ResetDraw()
		SetSize(4)
		SetCol(255,180,180,1)
		Text(jscrw*.35,y,"GAME",1,1)
		Text(jscrw*.65,jscrh-y,"OVER",1,1)
		
		Local ftxtt$=MyNth()
		If n>0
			SetSize(1)
			SetCol(0,125,255,0.5)
			Rect(jscrw*.35,(jscrh-(Float(y)/1.5))-16,jscrw*0.3,32)
			SetSize(2)
			SetCol(100,255,100,1)
			Text(jscrw*.5,jscrh-(Float(y)/1.5),"New Highscore\n           "+MyNth(),0.5,2)	
		Endif
	Endif
		
		If GameMode=10
			Ending=Ending+1
			If Ending=90
				GameMode=2;Ending=75;
				MusicPlayer.JM_Stop(1)
				If HasMusic=1 Then MusicPlayer.JM_Stop(1)
			Endif
		Endif
		If GameMode<10
			Ending=Ending-2
			If Ending<0 Then Ending=0
		Endif
		
	End

	Method LoadGame()
		' Reset all your variables here
		Score=0
		EndofGame=0
		Ending=0
		GameMode=10
		
		If GameType=1 Then MusicPlayer.JM_StartTune("Sheep Goes Left/Tune_12",37171650,100)
		If GameType=2 Then MusicPlayer.JM_StartTune("Retro/Manic Miner",37171650,100)
		If GameType=3 Then MusicPlayer.JM_StartTune("Retro/MarioEsque",37171650,100)
		
	End

	Method Game()
		CLS2D(0,0,80,1)
' ********************* Delete this shite, then add your own! v

		Seed=RandomSeed
		If Paused=0 Then RandomSeed=Millisecs()
		
		' Main sprawling
		For m=1 To ToSprites
			SetRot Rnd(360)
			SetSize(Rnd(-2,2),Rnd(-2,2))
			x=Rnd(jscrw);y=Rnd(jscrh)
			Alpha(Rnd(0.5,.75))
			a=Rnd(98,110)
			b=0
			If a>99 Then a=96
			If m>10 Then a=96
			If GameType=3 Then a=99
			If GameType=2 Then a=98

			If a=99 Or a=96 Then b=Rnd(0,3)
			'a=1;b=Rnd(0,3)
			DrawImg(a,x,y,b)
		Next
		
		ResetDraw()
		If Button(95,jscrw*.2,jscrh*.5,0) And mdis=0 And ToSprites>0 Then mdis=1;ToSprites=ToSprites-10;PlaySFX(99,0.8,0.5)
		If Button(95,jscrw*.8,jscrh*.5,2) And mdis=0 And ToSprites<MaxSprites-20 Then mdis=1;ToSprites=ToSprites+10;PlaySFX(99,1.2,0.5)

		SetSize(2)
		SetCol(100,255,100,0.75)
		Text jscrw/2,100,ToSprites,1,1
				
		ResetDraw()
		DrawImg(98,jscrw/2,jscrh/2)	

		SetRot(0)
		SetSize(1)

		' Set Score
		Score=ToSprites

		' Touches
		ResetDraw()
		For n=0 To 9
			If td[n]
				Line(tx[n]-50,ty[n]-50,tx[n]+50,ty[n]+50)
				Line(tx[n]-50,ty[n]+50,tx[n]+50,ty[n]-50)				
			Endif
		Next

' **************  Your game goes ^ here ^


		'	Score Display
		ShowScore=ShowScore-((ShowScore-Score)/6);If Abs(ShowScore-Score)<6 Then ShowScore=Score
		SetCol(100,255,100,0.8)
		SetSize(2)
		Text(jscrw/2,32,rstr(ShowScore,8,"0"),1,1)
		
	End	
End


Function Main()
	New MyApp
End
