Import mojo

Class JMPlayer
	Field JM_Filename$=""
	Field JM_Channels=8
	Field JM_Patterns=64
	Field JM_Patterns_Use=3
	Field JM_Tempo=95
	Field JM_Seed=0
	Field JM_SeedPlus=0
	Field JM_Loader=0
	Field JM_LoadImage:Image
	Field JM_Play[JM_Channels]
	Field JM_Available[JM_Channels*JM_Patterns]
	Field JM_Beat=0
	Field JM_Bars=5
	Field JM_NextBeat=0
	Field JM_Data[(((8*8)*64)*64)+1]
	Field JM_Instruments_Available[8]
	Field JM_Instrument_Use[8]
	Field JM_DrumA:Sound[9]
	Field JM_DrumB:Sound[9]
	Field JM_Instrument:Sound[8]
	Field JM_Instrument_Loaded[8]
	Field JM_Pattern_Use[8]
	Field JM_Patterns_Available[8]
	Field JM_Channel[8]
	Field JM_Fade#[8]
	Field JM_Pitch#[8]
	Field JM_Vol#[8]
	Field JM_Mute[8]
	Field JM_NextMute[8]
	Field JM_NextMuteOn[8]
	Field JM_Repeat
	Field JM_Chord#
	Field JM_ChordStructure$
	Field JM_Chords$[64]
	Field JM_Chords_Available=0
	Field JME_Play=0

	Field JM_Volume#=0.5
	
	Field JM_HaveChannels

	Method Rand(fa#,fb#)
		Return Floor(Rnd(fa,fb+0.99))
	End
	
	Method JM_Init(fc,Drums,Lead,Accompany,Bass)
		JM_HaveChannels=fc
		JM_Instruments_Available[1]=Drums
		JM_Instruments_Available[2]=Lead
		JM_Instruments_Available[3]=Accompany
		JM_Instruments_Available[4]=Bass
	End Method

	' ***********  Main routine
	Method JM_Alive_R()
		If JM_Loader>0
			Local n
			For n=1 To 3
				If JM_Loader>0 Then JM_LoadChunk()
			Next
		Endif
		Cls(0,0,0)
	End
	

	Method JM_Alive_U(Pause,MusicOn)
		If JM_Loader>0
		Endif
		If JME_Play=0 Then JM_Stop()
		
		If JME_Play=2 And JM_Loader=0 And Pause=0 And MusicOn=1
			JM_MusicPlay()
		Endif
		If Pause=1 Then JM_NextBeat=Millisecs()+150
		If (JME_Play=2) And (Pause=1 Or MusicOn=0)
			JM_Stop()
		Endif
	End


	' Loader
	Method JM_LoadChunk()		
		Select JM_Loader
			Case 2 JM_DrumA[1]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-1.wav") 
			Case 3 JM_DrumA[2]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-2.wav")
			Case 4 JM_DrumA[3]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-3.wav")
			Case 5 JM_DrumA[4]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-4.wav")
			Case 6 JM_DrumA[5]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-5.wav")
			Case 7 JM_DrumA[6]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-6.wav")
			Case 8 JM_DrumA[7]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-7.wav")
			Case 9 JM_DrumA[8]=LoadSound("inst/d"+JM_Instrument_Use[1]+"-8.wav")

			Case 12 JM_DrumB[1]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-1.wav")
			Case 13 JM_DrumB[2]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-2.wav")
			Case 14 JM_DrumB[3]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-3.wav")
			Case 15 JM_DrumB[4]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-4.wav")
			Case 16 JM_DrumB[5]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-5.wav")
			Case 17 JM_DrumB[6]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-6.wav")
			Case 18 JM_DrumB[7]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-7.wav")
			Case 19 JM_DrumB[8]=LoadSound("inst/d"+JM_Instrument_Use[2]+"-8.wav")
			
			Case 21 JM_Instrument[2]=LoadSound("inst/lead"+JM_Instrument_Use[3]+".wav")
			Case 22 JM_Instrument[3]=LoadSound("inst/accompany"+JM_Instrument_Use[4]+".wav")
			Case 23 JM_Instrument[4]=LoadSound("inst/bass"+JM_Instrument_Use[5]+".wav")
			
		End Select
		
		
		If JM_Loader=1
			DebugLog("Music File : "+JM_Filename);
			JM_LoadImage=LoadImage(JM_Filename,64,64,64,Image.MidHandle)
		Endif
		
		If JM_LoadImage<>Null
			'DebugLog "Loading Music "+JM_Loader+" : "+JM_LoadImage.Width()
			If JM_Loader>4 And JM_Loader<68
			Local PixelArray:Int[4096]
			Local ba,x,y,v,n,NID

				Cls(1,0,0)
				SetAlpha(1)
				SetColor(1,0,0)
				DrawRect(0,0,64,64)
				SetColor(255,255,255)
				DrawImage(JM_LoadImage,32,32,JM_Loader-5)
'				DrawImage(JM_LoadImage,32,32,0)
				
				
				ReadPixels(PixelArray,0,0,64,64,0,0)
				For y=0 To 63
				For x=0 To 7
					NID=(JM_Loader-5)*4096
					NID=NID+((y*8)+((x*8)*64))
					For n=0 To 7
						ba=PixelArray[(y*64)+((x*8)+(n))]
						
						v=0
						
						v=((ba & $FF))/8
						
'						If v>0 Then DebugLog (JM_Loader+":"+x+":"+y)
						JM_Data[NID+n]=v
						If JM_Data[NID+n]<0 Or JM_Data[NID+n]>31 Then JM_Data[NID+n]=0
						If JM_Data[NID+n]<>0 Then JM_Patterns_Available[x]=JM_Loader-5
					Next
				Next
				Next
			Endif
			
			Endif
			JM_Loader=JM_Loader+1
			JM_NextBeat=Millisecs()+100
			If JM_Loader>70 Then JM_Loader=0
	End


	' ************  MEWSIK
	
	Method JM_StartTune(Track$,NewSeed,Speed)
	Local n,x,y,r
	Track="tunes/"+Track+".png"
	DebugLog("Playing  "+JM_Filename+" - "+NewSeed)
		JM_SeedPlus=0
		JM_Seed=NewSeed
		JM_NextBeat=Millisecs()+100
		JM_Beat=0
		JM_Tempo=Speed
		JME_Play=2
		
		If Track<>JM_Filename
			JM_Loader=1
			JM_Filename=Track
			For x=0 To JM_Bars-1
				JM_Patterns_Available[x]=0
				JM_Pattern_Use[x]=0
			Next
		Endif
		
		For n=0 To JM_Bars-1
			JM_Channel[n]=JM_HaveChannels-n
		Next


		Seed=JM_Seed+JM_SeedPlus
		For n=0 To 10;r=Rand(1,5);Next
		
		JM_Instrument_Use[1]=Rand(1,JM_Instruments_Available[1])
		JM_Instrument_Use[2]=Rand(1,JM_Instruments_Available[1])
		JM_Instrument_Use[3]=Rand(1,JM_Instruments_Available[2])
		JM_Instrument_Use[4]=Rand(1,JM_Instruments_Available[3])
		JM_Instrument_Use[5]=Rand(1,JM_Instruments_Available[4])
	
		For x=0 To JM_Bars-1
			Seed=(JM_Seed+(JM_SeedPlus*9))+(x*7);For n=0 To 10;r=Rand(1,5);Next
			JM_Pattern_Use[x]=Rand(0,JM_Patterns_Available[x])
						JM_NextMute[x]=Rand(0,1)
						JM_NextMuteOn[x]=Rand(0,1)
						JM_Mute[x]=Rand(0,1)
		Next
		If JM_Mute[0]=1 And JM_Mute[1]=1 Then JM_Mute[0]=0
		JM_Repeat=Rand(1,2)*2	
		JM_ChordStructure="qqjj"
		
		
		
	End 
	
	Method JM_Stop(total=0)
		Local n
		For n=0 To JM_Bars-1
			If JM_Channel[n]>0 Then StopChannel(JM_Channel[n]);
		Next
		If total=1 Then JME_Play=0
	End


	Method JM_MusicPlay()
		If JM_NextBeat<Millisecs() Or JM_NextBeat>Millisecs()+123456

		Local x,NID,a,b,n
		Local txt$=""
			For x=0 To JM_Bars-1
				NID=JM_Pattern_Use[x]
				NID=(NID*4096)+((JM_Beat*8)+((x*8)*64))
				
				If JM_Data[NID+2]=27 And JME_Play=2
					a=JM_Repeat
					b=JM_Data[NID+3]
					If b=1 And (a Mod 2)=1 Then JM_Pattern_Use[x]=JM_Pattern_Use[x]+1
					If b=2 And (a Mod 2)=0 Then JM_Pattern_Use[x]=JM_Pattern_Use[x]-1
				Endif
				
				If JME_Play=2 Then NID=JM_Pattern_Use[x]
				NID=(NID*4096)+((JM_Beat*8)+((x*8)*64))
	
				JM_PlayNote(x,JM_Data[NID],JM_Data[NID+1],JM_Data[NID+2],JM_Data[NID+3])
				If JM_Data[NID+2]=8 Then JM_Beat=63
				txt=txt+JM_Data[NID]+" "+JM_Data[NID+1]+" - "+JM_Data[NID+2]+"   "
	
			Next
	'DebugLog txt
			Local JT#=(1.0/Float(JM_Tempo))*8000
			JM_NextBeat=JM_NextBeat+JT
			JM_Beat=(JM_Beat+1) Mod 64		
			
			If JM_Beat=0
				If JME_Play>1
					'DebugLog("New Pattern : "+JM_SeedPlus)
					'DebugLog(JM_Repeat+":"+JM_ChordStructure)
				Endif
				Seed=((JM_Seed+(JM_SeedPlus*9)));For n=0 To 15;a=Rand(1,5);Next
				If (JM_ChordStructure.Length())=1 Then JM_ChordStructure=" "+(JM_GetChord(Rand(0,4)))
				If (JM_ChordStructure.Length())>1 Then JM_ChordStructure=JM_ChordStructure[-(JM_ChordStructure.Length-1)..]
	
				JM_Repeat=JM_Repeat-1
				If JM_Repeat<1
				
					Seed=((JM_Seed+(JM_SeedPlus*9)));For n=0 To 10;a=Rand(1,5);Next
					JM_Repeat=Rand(1,2)*2
									
					JM_SeedPlus=JM_SeedPlus+1
					For x=0 To JM_Bars-1
						Seed=((JM_Seed+(JM_SeedPlus*9))+(x*7));For n=0 To 10;a=Rand(1,5);Next
						JM_Pattern_Use[x]=Rand(0,JM_Patterns_Available[x])
						If JME_Play>1 Then JM_Mute[x]=JM_NextMute[x]
						JM_NextMute[x]=Rand(0,1)
						JM_NextMuteOn[x]=Rand(0,1)
					Next
					If JME_Play>1 And JM_Mute[0]=1 And JM_Mute[1]=1 Then JM_Mute[0]=0
					
				Endif
			Endif
		Endif
	End Method
	

	Method JM_PlayNote(fBar,fNote,fEffect1=30,fEffect2=0,fEffect3=0)

	Local im=0
	Local n%,pitch#
	im=JM_Mute[fBar]
	If JME_Play>1 And JM_Repeat<2 And JM_Beat>=56 And JM_NextMuteOn[fBar]=1 And JM_NextMute[fBar]=0 Then im=JM_NextMute[fBar]
	
		JM_Chord=1
		If JME_Play>1 And JM_ChordStructure.Length>0 Then JM_Chord=GetPitch_Alpha(JM_ChordStructure[0])
	
	For n=0 To JM_Bars-1
		JM_Channel[n]=JM_HaveChannels-(n+1)
	Next
	
		If fBar=0 And fNote>0 And im=0 And JM_Channel[0]>0
			StopChannel(JM_Channel[0])
			Select fNote
				Case 13 If JM_DrumA[1]<>Null Then PlaySound(JM_DrumA[1],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 15 If JM_DrumA[2]<>Null Then PlaySound(JM_DrumA[2],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 17 If JM_DrumA[3]<>Null Then PlaySound(JM_DrumA[3],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 18 If JM_DrumA[4]<>Null Then PlaySound(JM_DrumA[4],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 20 If JM_DrumA[5]<>Null Then PlaySound(JM_DrumA[5],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 22 If JM_DrumA[6]<>Null Then PlaySound(JM_DrumA[6],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 24 If JM_DrumA[7]<>Null Then PlaySound(JM_DrumA[7],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
				Case 25 If JM_DrumA[8]<>Null Then PlaySound(JM_DrumA[8],JM_Channel[0] );SetChannelPan(JM_Channel[0],-0.35)
			End Select
			JM_Pitch[fBar]=1
			JM_Fade[fBar]=4
		Endif
		
		If fBar=1 And fNote>0 And im=0 And JM_Channel[1]>0
			StopChannel(JM_Channel[1])
			Select fNote
				Case 13 If JM_DrumB[1]<>Null Then PlaySound(JM_DrumB[1],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 15 If JM_DrumB[2]<>Null Then PlaySound(JM_DrumB[2],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 17 If JM_DrumB[3]<>Null Then PlaySound(JM_DrumB[3],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 18 If JM_DrumB[4]<>Null Then PlaySound(JM_DrumB[4],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 20 If JM_DrumB[5]<>Null Then PlaySound(JM_DrumB[5],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 22 If JM_DrumB[6]<>Null Then PlaySound(JM_DrumB[6],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 24 If JM_DrumB[7]<>Null Then PlaySound(JM_DrumB[7],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
				Case 25 If JM_DrumB[8]<>Null Then PlaySound(JM_DrumB[8],JM_Channel[1] );SetChannelPan(JM_Channel[1],0.35)
			End Select
			JM_Pitch[fBar]=1
			JM_Fade[fBar]=4
		Endif
		


		
		Local fv#=Float(fEffect1-1)/29
		If fv>1 Then fv=0;JM_Fade[fBar]=0
		If fv<0 Then fv=0
		If (fEffect1>0) And JM_Channel[fBar]>0 And im=0
			JM_Fade[fBar]=1.5;SetChannelVolume(JM_Channel[fBar],fv*JM_Volume);JM_Vol[fBar]=fv
		Endif
	
		fv=JM_Vol[fBar]
		JM_Fade[fBar]=JM_Fade[fBar]-0.1
		If JM_Fade[fBar]<0 Then JM_Fade[fBar]=0
		If JM_Fade[fBar]<1 Then fv=fv*JM_Fade[fBar]
		If (JM_Fade[fBar]<1) And JM_Channel[fBar]>0
			SetChannelVolume(JM_Channel[fBar],fv*JM_Volume);JM_Vol[fBar]=fv
		Endif

		If fBar>1 And fBar<5 And fNote>0 And im=0  And JM_Channel[fBar]>0
			StopChannel(JM_Channel[fBar])
			pitch=GetPitch(fNote)
			pitch=pitch*JM_Chord
			JM_Pitch[fBar]=pitch
			JM_Fade[fBar]=1.5
			SetChannelRate(JM_Channel[fBar],pitch)
			If JM_Instrument[fBar]<>Null
				PlaySound(JM_Instrument[fBar] ,JM_Channel[fBar],1)
			Endif
		Endif
		
	
	
	If im=0 And JM_Channel[fBar]>0
		Select fEffect2
			Case 1
				JM_Pitch[fBar]=JM_Pitch[fBar]+(Float(fEffect3)/Float(30*6))
				If JM_Pitch[fBar]>4 Then JM_Pitch[fBar]=4
				If JM_Channel[fBar]<>0 Then SetChannelRate(JM_Channel[fBar],JM_Pitch[fBar])
				
			Case 2
				JM_Pitch[fBar]=JM_Pitch[fBar]-(Float(fEffect3)/Float(30*6))
				If JM_Pitch[fBar]<0.25 Then JM_Pitch[fBar]=0.25
				If JM_Channel[fBar]<>0 Then SetChannelRate(JM_Channel[fBar],JM_Pitch[fBar])
	
			Case 3
				JM_Pitch[fBar]=JM_Pitch[fBar]+(Float(fEffect3)/Float(15))
				If JM_Pitch[fBar]>4 Then JM_Pitch[fBar]=4
				If JM_Channel[fBar]<>0 Then SetChannelRate(JM_Channel[fBar],JM_Pitch[fBar])
				
			Case 4
				JM_Pitch[fBar]=JM_Pitch[fBar]-(Float(fEffect3)/Float(15))
				If JM_Pitch[fBar]<0.25 Then JM_Pitch[fBar]=0.25
				If JM_Channel[fBar]<>0 Then SetChannelRate(JM_Channel[fBar],JM_Pitch[fBar])
		End Select
	Endif
		
	End Method
	
	Method JM_GetChord$(fn)
		Select fn
			Case 0 Return "qqqq"
			Case 1 Return "qqjj"
			Case 2 Return "qqbb"
			Case 3 Return "qbqb"
			Case 4 Return "qqqj"
			Case 5 Return "qqzz"
			Default Return "qqjj"
		End Select
		'Return JM_Chords$[fn]
	End Method

	
	' Pitch stuff

	Method GetPitch_Alpha#(note)
	Select note
		Case 122 Return 1.0/2
		Case 115 Return 1.059/2
		Case 120 Return 1.122/2
		Case 100 Return 1.189/2
		Case 99 Return 1.260/2
		Case 118 Return 1.335/2
		Case 103 Return 1.414/2
		Case 98 Return 1.498/2
		Case 104 Return 1.587/2
		Case 110 Return 1.682/2
		Case 106 Return 1.782/2
		Case 109 Return 1.888/2
		Case 113 Return 1.0
		Case 50 Return 1.059
		Case 119 Return 1.122
		Case 51 Return 1.189
		Case 101 Return 1.260
		Case 114 Return 1.335
		Case 53 Return 1.414
		Case 116 Return 1.498
		Case 54 Return 1.587
		Case 121 Return 1.682
		Case 55 Return 1.782
		Case 117 Return 1.888
		Case 105 Return 1.0*2
		Case 57 Return 1.059*2
		Case 111 Return 1.122*2
		Case 48 Return 1.189*2
		Case 112 Return 1.260*2
		Case 91 Return 1.335*2
		Case 61 Return 1.414*2
		Case 93 Return 1.498*2
	End Select
	End Method
	
	Method GetPitch#(fn)
		Select fn
				Case 1 Return 1.0/2
				Case 2 Return 1.059/2
				Case 3 Return 1.122/2
				Case 4 Return 1.189/2
				Case 5 Return 1.260/2
				Case 6 Return 1.335/2
				Case 7 Return 1.414/2
				Case 8 Return 1.498/2
				Case 9 Return 1.587/2
				Case 10 Return 1.682/2
				Case 11 Return 1.782/2
				Case 12 Return 1.888/2
				Case 13 Return 1.0
				Case 14 Return 1.059
				Case 15 Return 1.122
				Case 16 Return 1.189
				Case 17 Return 1.260
				Case 18 Return 1.335
				Case 19 Return 1.414
				Case 20 Return 1.498
				Case 21 Return 1.587
				Case 22 Return 1.682
				Case 23 Return 1.782
				Case 24 Return 1.888
				Case 25 Return 1.0*2
				Case 26 Return 1.059*2
				Case 27 Return 1.122*2
				Case 28 Return 1.189*2
				Case 29 Return 1.260*2
				Case 30 Return 1.335*2
				Case 31 Return 1.414*2
				Case 32 Return 1.498*2
		End Select
	End Method
	
	
	


End Class

